//
//  ViewController.m
//  Test
//
//  Created by dt on 16/6/2.
//  Copyright © 2016年 sanmiao. All rights reserved.
//

#import "ViewController.h"
#import "Masonry.h"
#import "CYXDTCollectCell.h"
#import "CYXDTSectionView.h"
#import "Kmodel.h"
@interface ViewController ()<UIImagePickerControllerDelegate,UINavigationControllerDelegate,UICollectionViewDataSource,UICollectionViewDelegate,UIActionSheetDelegate>{
    NSIndexPath*currentIndexPath;
     NSMutableDictionary*dic;
}
@property(nonatomic,strong)UICollectionView*collectionView;
@property (nonatomic,strong) UIImagePickerController *picker;
@property(nonatomic,strong)UIActionSheet*actionSheet;
@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    
    dic=[[NSMutableDictionary alloc]init];
    
  
    
    
    NSMutableArray*arr=[NSMutableArray array];
    
    NSMutableArray*arr1=[NSMutableArray array];
    [dic setObject:arr forKey:@"0"];
    [dic setObject:arr1 forKey:@"1"];
    
    
    [self.view addSubview:self.collectionView];
    [_collectionView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.top.bottom.mas_equalTo(0);
    }];
    
    
}

-(UICollectionView*)collectionView{
    if (!_collectionView) {
        UICollectionViewFlowLayout*flowLayOut=[[UICollectionViewFlowLayout alloc]init];
        flowLayOut.scrollDirection=UICollectionViewScrollDirectionVertical;
        
        flowLayOut.itemSize=CGSizeMake(80,80 );
        
        flowLayOut.minimumInteritemSpacing=0;
        flowLayOut.minimumLineSpacing=10;
        flowLayOut.sectionInset=UIEdgeInsetsMake(10,10,0, 10);
        
        
        _collectionView=[[UICollectionView alloc]initWithFrame:CGRectZero collectionViewLayout:flowLayOut];
        _collectionView.backgroundColor=[UIColor whiteColor];
        
        [_collectionView registerClass:[CYXDTCollectCell class] forCellWithReuseIdentifier:@"cell"];
        [_collectionView registerClass:[CYXDTSectionView class] forSupplementaryViewOfKind:UICollectionElementKindSectionHeader withReuseIdentifier:@"header"];
        [_collectionView registerClass:[UICollectionViewCell class] forCellWithReuseIdentifier:@"UICollectionViewCell"];
        
        _collectionView.delegate=self;
        _collectionView.dataSource=self;
        
        
        
    }
    return _collectionView;
    
}

-(UICollectionViewCell*)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath{
    
    NSString*str=[NSString stringWithFormat:@"%ld",(long)indexPath.section];
    
    NSArray*arr=dic[str];
    
    if (indexPath.row==arr.count) {
        UICollectionViewCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:@"UICollectionViewCell" forIndexPath:indexPath];
        cell.backgroundColor=[UIColor redColor];
        
        return cell;
        
        
        
    }else{
        
        CYXDTCollectCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:@"cell" forIndexPath:indexPath];
        
        [cell.cut addTarget:self action:@selector(cut:) forControlEvents:UIControlEventTouchUpInside];
        
        cell.backgroundColor=[UIColor redColor];
        if (arr.count>0) {
            
            
            
            
            Kmodel*model=arr[indexPath.row];
            
            
            cell.imV.image=model.image;
        }
        
        
        return cell;
    }
    
    
}
-(void)cut:(UIButton*)sender{
    sender.selected=!sender.selected;
    
    
    
    
    NSIndexPath*index=[self.collectionView indexPathForCell:(CYXDTCollectCell*)sender.superview];
    
    

    
    
    
    
    
}

-(NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section{
    
    NSString*str=[NSString stringWithFormat:@"%ld",(long)section];
    
    NSArray*arr=dic[str];
    
    
    return arr.count+1;
    
}

-(NSInteger)numberOfSectionsInCollectionView:(UICollectionView *)collectionView{
    return 2;
}

- (UICollectionReusableView *)collectionView:(UICollectionView *)collectionView viewForSupplementaryElementOfKind:(NSString *)kind atIndexPath:(NSIndexPath *)indexPath
{
    
    CYXDTSectionView *view = [collectionView dequeueReusableSupplementaryViewOfKind:UICollectionElementKindSectionHeader withReuseIdentifier:@"header" forIndexPath:indexPath];
    
    NSArray*arr=@[@"发布商品图文详情图片：(最多10张)",@"商品轮播图图片：(最多4张)"];
    
    
    view.lab.text =  arr[indexPath.section];
    
    
    return view;
    ;
    
    
    
    
    
    
}
-(void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath{
    
    
    currentIndexPath=indexPath;
    if (indexPath.section==0) {
        if (indexPath.row==10) {
            return;
        }
        
    }else{
        if (indexPath.row==4) {
            return;
        }
        
    }
    
    
    NSString*str=[NSString stringWithFormat:@"%ld",(long)indexPath.section];
    NSArray*arr= dic[str];
    
    if (indexPath.row==arr.count) {
        [self callActionSheetFunc];
        
    }else{
        [collectionView deselectItemAtIndexPath:indexPath animated:YES];
    }
    
    
    
}

-(CGSize)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout *)collectionViewLayout referenceSizeForHeaderInSection:(NSInteger)section{
    CGSize size={0,50};
    return size;
}
#pragma mark---打开相册 照相机

/**
 @ 调用ActionSheet
 */
- (void)callActionSheetFunc{
    if([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeCamera]){
        self.actionSheet = [[UIActionSheet alloc] initWithTitle:@"选择图像" delegate:self cancelButtonTitle:@"取消" destructiveButtonTitle:nil otherButtonTitles:@"拍照", @"从相册选择",  nil];
    }else{
        self.actionSheet = [[UIActionSheet alloc] initWithTitle:@"选择图像" delegate:self cancelButtonTitle:@"取消"destructiveButtonTitle:nil otherButtonTitles:@"从相册选择", nil];
    }
    
    self.actionSheet.tag = 1000;
    [self.actionSheet showInView:self.view];
}


// Called when a button is clicked. The view will be automatically dismissed after this call returns
- (void)actionSheet:(UIActionSheet *)actionSheet clickedButtonAtIndex:(NSInteger)buttonIndex{
    if (actionSheet.tag == 1000) {
        NSUInteger sourceType = UIImagePickerControllerSourceTypePhotoLibrary;
        // 判断是否支持相机
        if([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeCamera]) {
            switch (buttonIndex) {
                case 0:
                    //来源:相机
                    sourceType = UIImagePickerControllerSourceTypeCamera;
                    break;
                case 1:
                    //来源:相册
                    sourceType = UIImagePickerControllerSourceTypePhotoLibrary;
                    break;
                case 2:
                    return;
            }
        }
        else {
            if (buttonIndex == 1) {
                return;
            } else {
                sourceType = UIImagePickerControllerSourceTypeSavedPhotosAlbum;
            }
        }
        // 跳转到相机或相册页面
        UIImagePickerController *imagePickerController = [[UIImagePickerController alloc] init];
        imagePickerController.delegate = self;
        imagePickerController.allowsEditing = YES;
        imagePickerController.sourceType = sourceType;
        
        [self presentViewController:imagePickerController animated:YES completion:^{
            
        }];
    }
}

- (void)imagePickerController:(UIImagePickerController *)picker didFinishPickingMediaWithInfo:(NSDictionary *)info
{     UIImage *image = [info objectForKey:UIImagePickerControllerOriginalImage];
    
    Kmodel*model=[[Kmodel alloc]init];
    model.image=image;
    model.isTrue=@"NO";
    
    NSString*str=[NSString stringWithFormat:@"%ld",(long)currentIndexPath.section];
    
    NSMutableArray*arr=dic[str];
    
    [arr addObject:model];
    
    
    
    [_collectionView reloadData];

    
    
    [picker dismissViewControllerAnimated:YES completion:^{
        
        
        
        
        
        
    }];
   
    
    
    
    
}










- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
